#pragma once

#include <mongoose.h>
#include "Sicmaster.H"
#include "Sicobject.H"
#include <string>
#include <map>

class DynamicObjects
{
	public:
		std::string render_object_list();
		std::string cleanpath(const char * const);
		DynamicObjects(Sicmaster & sicmaster):sicmaster(sicmaster) {};
		~DynamicObjects() {};

	private:
		std::string _cleanpath (const char * const path);
		std::map<unsigned int, Sicobject *> _themap;
		Sicmaster & sicmaster;

};
